{% extends 'forms/base_widget.html' %}


{% block html %}
    {% set value_json = field._value() | tojson %}
    <input type="hidden" id="{{ field.id }}" name="{{ field.name }}" value="{{ value_json | forceescape }}">
    <div id="{{ field.id }}-widget">
        <table class="i-table-widget">
            <thead data-tooltip-anchor>
                <tr>
                    {% for _, title in field.fields -%}
                        <th>{{ title }}</th>
                    {% endfor -%}
                    <th class="action-column">Action</th>
                </tr>
            </thead>
            <tbody></tbody>
        </table>
        <a href="#" class="js-add-row i-button icon-plus i-form-button">{% trans %}Add{% endtrans %}</a>
    </div>
{% endblock %}


{% block javascript %}
    <script>
        (function() {
            'use strict';

            var columns = {{ field.fields | tojson }};
            var widget = $('#{{ field.id }}-widget');
            var widgetBody = widget.children('table').children('tbody');
            var field = $('#{{ field.id }}');
            var data = JSON.parse(field.val());
            var deleteButton = $('<a>', {'class': 'action-icon icon-remove js-remove-row', 'href': '#', 'title': $T('Delete')});
            var saveButton = $('<a>', {'class': 'action-icon icon-floppy js-save-row', 'href': '#', 'title': $T('Save')});
            var editButton = $('<a>', {'class': 'action-icon icon-edit js-edit-row', 'href': '#', 'title': $T('Edit')});
            var cancelButton = $('<a>', {'class': 'action-icon icon-close js-cancel-edit', 'href': '#', 'title': $T('Cancel')});

            if (!data.length) {
                createRow();
            }

            data.forEach(function(item, i) {
                createRow(item);
            });

            widget.on('click', '.js-remove-row', function(e) {
                e.preventDefault();
                removeRow($(this).closest('tr'));
            }).on('click', '.js-save-row', function(e) {
                e.preventDefault();
                var row = $(this).closest('tr');
                var item = {};
                columns.forEach(function(col, i) {
                    item[col[0]] = row.find('input').eq(i).val();
                });
                if (row.data('hasItem')) {
                    data[row.index()] = item;
                } else {
                    data.push(item);
                    row.data('hasItem', true);
                }
                updateField();
                updateRow(row, false);
            }).on('click', '.js-add-row', function(e) {
                e.preventDefault();
                createRow();
            }).on('click', '.js-cancel-edit', function(e) {
                e.preventDefault();
                var row = $(this).closest('tr');
                if (!row.data('hasItem')) {
                    removeRow(row);
                } else {
                    updateRow(row, false);
                }
            }).on('click', '.js-edit-row', function(e) {
                e.preventDefault();
                var row = $(this).closest('tr');
                updateRow(row, true);
            }).on('keypress', 'input', function(e) {
                if (e.keyCode == 13) {
                    e.preventDefault();
                    $(this).closest('tr').find('.js-save-row').trigger('click');
                } else if(e.keyCode == 27) {
                    e.preventDefault();
                    $(this).closest('tr').find('.js-cancel-edit').trigger('click');
                }
            });

            function makeColData(item, col, forceEditable) {
                return (item && !forceEditable) ? {
                    text: item[col[0]]
                } : {
                    html: $('<input>', {
                        'type': 'text',
                        'class': 'table-input',
                        'value': item ? item[col[0]] : ''
                        // can't set placeholder here due to the jquery.placeholder plugin
                    }).attr('placeholder', col[1])
                };
            }

            function createRow(item) {
                var row = $('<tr>');
                row.data('hasItem', !!item);
                columns.forEach(function(col) {
                    $('<td>', makeColData(item, col)).appendTo(row);
                });
                $('<td>', {
                    'html': item ? deleteButton.clone().add(editButton.clone()) : cancelButton.clone().add(saveButton.clone()),
                    'class': 'js-action-col'
                }).appendTo(row);
                widgetBody.append(row);
                repositionTooltips();
            }

            function updateRow(row, editMode) {
                row.children('td:not(.js-action-col)').each(function(i) {
                    $(this).replaceWith($('<td>', makeColData(data[row.index()], columns[i], editMode)));
                });
                if (editMode) {
                    row.children('.js-action-col').html(cancelButton.clone().add(saveButton.clone()));
                } else {
                    row.children('.js-action-col').html(deleteButton.clone().add(editButton.clone()));
                }
            }

            function removeRow(row) {
                if (row.data('hasItem')) {
                    data.splice(row.index(), 1);
                    updateField();
                }
                row.remove();
                repositionTooltips();
            }

            function updateField() {
                field.val(JSON.stringify(data));
            }
        })();
    </script>
{% endblock %}
